// DS1302 ̿  ð

#include <reg51.h>

sbit SCLK=P1^0;			// DS1302 SCLK
sbit IO=P1^1;			// DS1302 I/O
sbit RST=P1^2;			// DS1302 RST

sbit sw1=P1^3;			// (ð   )
sbit sw2=P1^4;			// ׸ (⵵, ,  )
sbit sw3=P1^5;			//  ׸ 
sbit sw4=P1^6;			// ʸ 

sbit LCD_RS=P2^0;		// LCD RS
sbit LCD_RW=P2^1;		// LCD RW
sbit LCD_CE=P2^2;		// LCD CE
sbit busy_flag=P0^7;		// LCD  ˻ ÷

sbit buzzer=P2^4;		// 

char *ptr;			//  

code unsigned char MSG1[]="20";
code unsigned char MSG2[]=".";
code unsigned char MSG3[]=":";

code unsigned char MSG_SUN[]="Sun";
code unsigned char MSG_MON[]="Mon";
code unsigned char MSG_TUE[]="Tue";
code unsigned char MSG_WED[]="Wed";
code unsigned char MSG_THU[]="Thu";
code unsigned char MSG_FRI[]="Fri";
code unsigned char MSG_SAT[]="Sat";

code unsigned char MSG_AM[]="AM ";
code unsigned char MSG_PM[]="PM ";

unsigned char second, minute, hour, ampm, date, month, day, year;

void delay(int i)    			// ð Լ
{
	while(i--);
}

void beep(void)    			// 
{
	buzzer=0;
	delay(0x4200);
	buzzer=1;
}

void lcd_busy(void)			//  ÷׸ ˻ϴ Լ
{
	unsigned char busy;

	LCD_CE=0;			// LCD 𽺿̺
	busy_flag=1;			// P0.7=High
	LCD_RW=1;			// R/W=High(Read)
	LCD_RS=0;			// LCD_RS=L(Instruction)
	do {
		busy=P0;
		LCD_CE=0;
		LCD_CE=1;
	} while(busy&=0x80);
	LCD_CE=0;			// LCD 𽺿̺
}

void cmd_write(unsigned char Command)	// LCD ɾ  Լ
{
	P0=Command;
	LCD_RS=0;			// LCD_RS=Low(Instruction)
	LCD_RW=0;			// R/W=Low(Write)
	LCD_CE=1;			// LCD ο̺
	LCD_CE=0;			// LCD 𽺿̺
	lcd_busy();
}

void data_write(unsigned char Data)	// LCD ͸  ƾ
{
	P0=Data;
	LCD_RS=1;			// LCD_RS=High(Data)
	LCD_RW=0;			// R/W=Low(Write)
	LCD_CE=1;			// LCD ο̺
	LCD_CE=0;			// LCD 𽺿̺
	lcd_busy();
}

void lcd_initialze(void)		// LCD ʱȭ 
{
	cmd_write(0x38);		//  (8Ʈ, 57Ʈ, 2)
	delay(0x0200);			// ù ° (4.1ms )
	cmd_write(0x38);
	delay(0x08);			//  ° (100us )
	cmd_write(0x38);
	cmd_write(0x0c);		// ÷  ɾ(÷ on, Ŀ on,  off)
	cmd_write(0x06);		// Ʈ  (巹 , Ʈ )
	cmd_write(0x01);		// ÷ Ŭ, Ŀ Ȩ ġ
}

void disp_data(unsigned char Data)	// ð ͸ LCD ÷ϴ Լ
{
	unsigned char temp;

	temp=Data;
	temp=temp>>4;
	temp=temp+0x30;			// ASCII ڵ ȯ
  	data_write(temp);		// LCD  4Ʈ ÷

	temp=Data & 0x0f;
	temp=temp+0x30;			// ASCII ڵ ȯ
  	data_write(temp);		// LCD  4Ʈ ÷
}

void disp_msg(void)			// LCD ޽ ÷ϴ Լ
{
	char *str;

	str=ptr;
	do {
 		data_write(*str);
		str++;
	} while(*str);
 }

void byte_write(unsigned char w_addr, unsigned char w_data)
{					// DS1302 1Ʈ ͸  Լ
	unsigned char i;

	RST=1;				// RST=High
	for (i=0; i<8; i++) {		//   巹
		if (w_addr & 0x01) IO=1;
		else IO=0;
		SCLK=1;			// SCLK=High
		SCLK=0;			// SCLK=Low
		w_addr >>= 1;
	}

	for (i=0; i<8; i++) {		//  
		if (w_data & 0x01) IO=1;
		else IO=0;
		SCLK=1;			// SCLK=High
		SCLK=0;			// SCLK=Low
		w_data >>= 1;
	}
	RST=0;				// RST=Low
}

unsigned char byte_read(unsigned char r_addr)
{					// DS1302 1Ʈ ͸ д Լ
	unsigned char i, r_data, TmpByte;

	RST=1;				// RST=High
	for (i=0; i<7; i++) {		//   巹(Ʈ -1)
		if (r_addr & 0x01) IO=1;
		else IO=0;
		SCLK=1;			// SCLK=High
		SCLK=0;			// SCLK=Low
		r_addr >>= 1;
	}
	if (r_addr & 0x01) IO=1;	// 8° Ʈ I/O 
	else IO=0;
	SCLK=1;				// SCLK=High

	r_data=0x00;
	for (i=0; i<8; i++) {
		SCLK=0;			// SCLK=Low
		TmpByte=IO;
		TmpByte <<= 7;
		r_data >>= 1;
		r_data |= TmpByte;
		SCLK=1;			// SCLK=H 
	}
	RST=0;				// RST=L
	return r_data;
}

void year_set(void)			//  ϴ Լ
{
	unsigned char esc;
	while(sw1);
	byte_write(0x8e,0x00);		//  𽺿̺(WP=0)
	cmd_write(0x82);		// Ŀ 1 3 ű
	cmd_write(0x0f);		// ÷  ɾ(÷ on, Ŀ on,  on)

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			year++;
			if (year==0x0a) year=0x10;	// BCD ȯ
			else if (year==0x1a) year=0x20;
			else if (year==0x2a) year=0x30;
			else if (year==0x3a) year=0x40;
			else if (year==0x4a) year=0x50;
			else if (year==0x5a) year=0x60;
			else if (year==0x6a) year=0x70;
			else if (year==0x7a) year=0x80;
			else if (year==0x8a) year=0x90;
			else if (year==0x9a) year=0x00;
			disp_data(year);	//   2ڸ LCD ÷
			cmd_write(0x82);	// Ŀ 1 3 ű
		}
	} while(esc);
	byte_write(0x8c,year);		// DS1302 (  )
}

void mont_set(void)			//  ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0x85);		// Ŀ 1 6 ű
	month=month & 0x1f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			month++;
			if (month==0x0a) month=0x10;
			else if (month==0x13) month=0x01;
			disp_data(month);	//  LCD ÷
			cmd_write(0x85);	// Ŀ 1 6 ű
		}
	} while(esc);
	byte_write(0x88, month);	// DS1302 (  )
}

void date_set(void)			//  ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0x88);		// Ŀ 1 9 ű
	date=date & 0x3f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			date++;
			if (date==0x0a) date=0x10;
			else if (date==0x1a) date=0x20;
			else if (date==0x2a) date=0x30;
			else if (date==0x32) date=0x01;
			disp_data(date);	// LCD  ÷
			cmd_write(0x88);	// Ŀ 1 9 ű
		}
	} while(esc);
	byte_write(0x86,date);		// DS1302 (  )
}

void day_display(unsigned char week)	//  ÷ϴ Լ
{
	switch(week) {
		case 1: 
			ptr=MSG_SUN; disp_msg(); break;	// LCD 'Sun' ÷
		case 2: 
			ptr=MSG_MON; disp_msg(); break;	// LCD 'Mon' ÷
		case 3:
			ptr=MSG_TUE; disp_msg(); break;	// LCD 'Tue' ÷
		case 4:
			ptr=MSG_WED; disp_msg(); break;	// LCD 'Wed' ÷
		case 5:
			ptr=MSG_THU; disp_msg(); break;	// LCD 'Thu' ÷
		case 6:
			ptr=MSG_FRI; disp_msg(); break;	// LCD 'Fri' ÷
		case 7:
			ptr=MSG_SAT; disp_msg(); break;	// LCD 'Sat' ÷
	}
}

void day_set(void)			//  ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0x8b);		// Ŀ 1 12 ű
	day=day & 0x07;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			day++;
			if (day==0x08) day=0x01;
			day_display(day);
			cmd_write(0x8b);	// Ŀ 1 12 ű
		}
	} while(esc);
	byte_write(0x8a,day);		// DS1302 (  )
}

void ampm_set(void)			// /ĸ ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0xc0);		// Ŀ 2 1 ű
	ampm=hour & 0x20;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		// / 
			while(sw3);
			if (ampm) {
				ampm=0;
				ptr=MSG_AM;	// LCD 'AM' ÷
				disp_msg();
			}
			else {
				ampm=1;
				ptr=MSG_PM;	// LCD 'PM' ÷
				disp_msg();
			}
			cmd_write(0xc0);	// Ŀ 2 1 ű
		}
	} while(esc);
	if (ampm) hour=hour | 0x20;
	else hour=hour & 0x9f;
	byte_write(0x84,hour);		// DS1302 ( / )
}

void hour_set(void)			// ø ϴ Լ
{
	unsigned char esc, temp;
	while(sw2);
	cmd_write(0xc3);		// Ŀ 2 4 ű
	temp=hour & 0xe0;
	hour=hour & 0x1f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		// ø +1
			while(sw3);
			hour++;
			if (hour==0x0a) hour=0x10;
			else if (hour==0x13) hour=0x01;
			disp_data(hour);	// LCD  ÷
			cmd_write(0xc3);	// Ŀ 2 4 ű
		}
	} while(esc);
	hour=(hour | temp) | 0x80;	// 12 
	byte_write(0x84,hour);		// DS1302 (  )
}

void mint_set(void)			//  ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0xc6);		// Ŀ 2 7 ű
	minute=minute & 0x7f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			minute++;
			if (minute==0x0a) minute=0x10;
			else if (minute==0x1a) minute=0x20;
			else if (minute==0x2a) minute=0x30;
			else if (minute==0x3a) minute=0x40;
			else if (minute==0x4a) minute=0x50;
			else if (minute==0x5a) minute=0x00;
			disp_data(minute);	// LCD  ÷
			cmd_write(0xc6);	// Ŀ 2 7 ű
		}
	} while(esc);
	byte_write(0x82,minute);		// DS1302 (  )
}

void secd_set(void)			// ʸ ϴ Լ
{
	unsigned char esc;
	while(sw2);
	cmd_write(0xc9);		// Ŀ 2 10 ű
	second=second & 0x7f;

	esc=1;
	do {
		if (sw1) esc=0;
		if (sw2) esc=0;
		if (sw3) {		// ʸ +1
			while(sw3);
			second++;
			if (second==0x0a) second=0x10;
			else if (second==0x1a) second=0x20;
			else if (second==0x2a) second=0x30;
			else if (second==0x3a) second=0x40;
			else if (second==0x4a) second=0x50;
			else if (second==0x5a) second=0x00;
			disp_data(second);	// LCD  ÷
			cmd_write(0xc9);	// Ŀ 2 10 ű
		}
	} while(esc);
	byte_write(0x80,second);	// DS1302 (  )
	byte_write(0x8e,0x80);		//   ο̺
	cmd_write(0x0c);		// ÷  ɾ(÷ on, Ŀ off,  off)
}

void read_time(void)			// DS1302κ ð  д Լ
{
	byte_write(0x8e,0x00);		//   𽺿̺(WP=0)
	second=byte_read(0x81);		// DS1302 ʸ 
	minute=byte_read(0x83);		// DS1302  
	hour=byte_read(0x85);		// DS1302 ø 
	date=byte_read(0x87);		// DS1302  
	month=byte_read(0x89);		// DS1302  
	day=byte_read(0x8b);		// DS1302  
	year=byte_read(0x8d);		// DS1302  
}

void disp_time(void)			// LCD ð  ÷ϴ Լ
{
	unsigned char min0, sec0;
	cmd_write(0x80);		// Ŀ 1 1 ű
	ptr=MSG1;			// LCD '20' ÷
	disp_msg();
	disp_data(year);		//   2ڸ ÷
	ptr=MSG2;			// LCD '.' ÷
	disp_msg();

	disp_data(month & 0x1f);
	ptr=MSG2;			// LCD '.' ÷
	disp_msg();

	disp_data(date & 0x3f);		// LCD  ÷
	ptr=MSG2;			// LCD '.' ÷
	disp_msg();

	day_display(day & 0x07);	// LCD  ÷

	cmd_write(0xc0);		// Ŀ 2 1 ű
	if (hour & 0x20) {
		ptr=MSG_PM;		// LCD 'PM' ÷
		disp_msg();
	}
	else {
		ptr=MSG_AM;		// LCD 'AM' ÷
		disp_msg();
	}

	disp_data(hour & 0x1f);		// LCD  ÷
	ptr=MSG3;			// LCD '.' ÷
	disp_msg();

	disp_data(minute & 0x7f);	// LCD  ÷
	ptr=MSG3;			// LCD '.' ÷
	disp_msg();

	disp_data(second & 0x7f);	// LCD  ÷

	min0=minute & 0x7f;
	sec0=second & 0x7f;
	if (min0==0) {
		if (sec0==0) beep();
	}
}

void sec_reset(void)			// ʸ 00 ϴ Լ
{
	while(sw4);
	byte_write(0x8e,0x00);		//   𽺿̺(WP=0)
	second=second & 0x80;
	byte_write(0x8e,0x00);		//  (  𽺿̺)
	byte_write(0x80,second);	// DS1302 (  )
}

void main(void)
{
	lcd_initialze();		// LCD ʱȭ
	do {
		if (sw1) {		// sw1 ˻
			year_set();	//  
			mont_set();	//  
			date_set();	//  
			day_set();	//  
			ampm_set();	// / 
			hour_set();	//  
			mint_set();	//  
			secd_set();	//  
			read_time();	//  ð 
			disp_time();	//  ð ÷
		}
		else if (sw4) {		// sw4 ˻
			sec_reset();	// ʸ 0 
			read_time();	//  ð 
			disp_time();	//  ð ÷
		}
		else {
			delay(0x04d0);
			read_time();	//  ð 
			disp_time();	//  ð ÷
		}
	} while(1);
}